Codeforces 672D Robin Hood(二分好题)

D. Robin Hood
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

We all know the impressive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

There are n citizens in Kekoland, each person has ci coins. Each day, Robin Hood will take exactly 1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest's 1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire in k days. He decided to spend these last days with helping poor people.

After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too.

Your task is to find the difference between richest and poorest persons wealth after k days. Note that the choosing at random among richest and poorest doesn't affect the answer.

Input

The first line of the input contains two integers n and k (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood's retirement.

The second line contains n integers, the i-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

Output

Print a single line containing the difference between richest and poorest peoples wealth.

Examples
input
4 1
1 1 4 2
output
2
input
3 1
2 2 2
output
0
Note

Lets look at how wealth changes through day in the first sample.

  1. [1, 1, 4, 2]
  2. [2, 1, 3, 2] or [1, 2, 3, 2]

So the answer is 3 - 1 = 2

In second sample wealth will remain the same for each person

 

 

题目链接:Codeforces 672D

题意就是求k天之后这个数列中最大和最小值之差应为多少,可以用二分去求出k天之后的最大值和最小值,显然对于最小值,它的下界为初始序列的最小值,随着k天过去,必定不会下降,又因为题意是从最大值偷取1单位到最小值,因此最小值过多少天必定不会超过整个数列的平均值,因此它的上界是$\lfloor {{\Sigma c_i} / n} \rfloor$;对于最大值来说,它的上界显然是最好情况——数列初始的最大值,随着时间过去最大值必定减小,但与最小值类似也不会小于平均值,当${\Sigma c_i} \%n!=0$时说明最终最大值必定会比平均值多1,因此它此时的下界为$\lfloor {\Sigma c_i} /n \rfloor+1$,否则下界为$\lfloor{\Sigma c_i} /n \rfloor$,对于当前二分的最值,如果可行,那么说明最终的结果肯定优于或等于当前结果,继续二分下去,就能得到最后的结果

代码:

#include <stdio.h>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <bitset>
#include <string>
#include <stack>
#include <cmath>
#include <queue>
#include <set>
#include <map>
using namespace std;
#define INF 0x3f3f3f3f
#define LC(x) (x<<1)
#define RC(x) ((x<<1)+1)
#define MID(x,y) ((x+y)>>1)
#define fin(name) freopen(name,"r",stdin)
#define fout(name) freopen(name,"w",stdout)
#define CLR(arr,val) memset(arr,val,sizeof(arr))
#define FAST_IO ios::sync_with_stdio(false);cin.tie(0);
typedef pair<int, int> pii;
typedef long long LL;
const double PI = acos(-1.0);
const int N = 500010;
LL arr[N];
int n;
LL k;

LL checkpoor(LL mid, LL res)
{
    for (int i = 0; i < n; ++i)
    {
        if (arr[i] < mid)
        {
            res -= (mid - arr[i]);
        }
    }
    return res >= 0;
}
LL checkrich(LL mid, LL res)
{
    for (int i = 0; i < n; ++i)
    {
        if (arr[i] > mid)
            res -= (arr[i] - mid);
    }
    return res >= 0;
}
int main(void)
{
    int i;
    while (~scanf("%d%I64d", &n, &k))
    {
        LL sum = 0;
        for (i = 0; i < n; ++i)
        {
            scanf("%I64d", arr + i);
            sum += arr[i];
        }
        LL Max = 0, Min = 0;
        //poorest
        LL L = *min_element(arr, arr + n), R = sum / n;
        while (L <= R)
        {
            LL mid = MID(L, R);
            if (checkpoor(mid, k))
            {
                L = mid + 1;
                Min = mid;
            }
            else
                R = mid - 1;
        }
        //richest
        L = sum / n + (sum % n != 0), R = *max_element(arr, arr + n);
        while (L <= R)
        {
            LL mid = MID(L, R);
            if (checkrich(mid, k))
            {
                R = mid - 1;
                Max = mid;
            }
            else
                L = mid + 1;
        }
        printf("%I64d\n", Max - Min);
    }
    return 0;
}

转载于:https://www.cnblogs.com/Blackops/p/7372567.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个k,需要找到一个子段,该子段中不超过k个不同的字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同的个每次如果这个小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种。使用一个map来判断的种类。遍历序列,如果当前字在map中不存在,则将种类sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值